﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace VarePortableClassLibrary
{
    [DataContract]
    [KnownType(typeof(Vare))]
    public class Varekartotek: IVarekartotek
    {
        private List<IVare> varesamling;
        [DataMember]
        public List<IVare> Varesamling
        {
            get { return varesamling; }
            set { varesamling = value; }
        }

        public Varekartotek()
        {
            varesamling = new List<IVare>();
        }

        public void OpretTestVarer()
        {
            varesamling.Add(new Vare(1001, "A4 blok ternet med huller", 10, 3.98f, "kasser", 3.68f, 30, 40, 100));
            varesamling.Add(new Vare(1002, "A4 blok linieret med huller", 20, 3.88f, "boxe", 3.65f, 40, 60, 20));
            varesamling.Add(new Vare(1003, "Blyant Viking 400x2", 110, 0.64f, "æsker", 0.50f, 500, 620, 200));
            varesamling.Add(new Vare(1004, "Blyant Viking 800x2", 210, 0.66f, "æsker", 0.55f, 410, 615, 200));
        }

        public IVare OpretVare(int varenr, string betegnelse, float salgsEnhedsPris, string enhed, float indkøbsEnhedsPris, int minimumAntal)
        {
            Vare nyVare = new Vare(varenr, betegnelse, 0, 3.98f, "kasser", 3.68f, 0, 0, 100);
            Varesamling.Add(nyVare);
            return nyVare;
        }

        public IVare FindVarePåVarenr(int varenr)
        {
            foreach (IVare vare in varesamling)
            {
                if (vare.Varenr == varenr)  // test om vare har det ønskede varenr
                    return vare;            // gevinst - vi returnere med den fundne
            }
            return null;  // vi har været alle varer igennen uden held og returnere null-reference
        }

        public List<IVare> HentVarerMedAntalUnderMinimum()
        {
            List<IVare> udvalgteVarer = new List<IVare>(); 
            foreach (IVare vare in varesamling)
            {
                if (vare.AntalPåLager < vare.MinimumAntal)  // test om under minimum
                {
                    udvalgteVarer.Add(vare);
                }
            }
            return udvalgteVarer;
        }

        public IVare[] HentAlleVarer()
        {
            return varesamling.ToArray();
        }
    }
}
